Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 486)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 493)
@@ -1055,110 +1217,199 @@
 
 #if defined( __parallel )
-                   IF ( data_output_2d_on_each_pe )  THEN
-!
-!--                   Output of partial arrays on each PE. If the cross section 
-!--                   does not reside on the PE, output special index values.
+                   IF ( netcdf_output  .AND.  netcdf_data_format > 2 )  THEN
+!
+!--                   ATTENTION: The following lines are a workaround, because
+!--                              independet output does not work with the
+!--                              current NetCDF4 installation. Therefore, data
+!--                              are transferred from PEs having the cross
+!--                              sections to other PEs along y having no cross
+!--                              section data. Some of these data are the
+!--                              output.
+!--                   BEGIN WORKAROUND---------------------------------------
+                      IF ( npex /= 1  .AND.  section(is,s) /= -1)  THEN
+                         ALLOCATE( local_2d_l(nys-1:nyn+1,nzb:nzt+1) )
+                         local_2d_l = 0.0
+                         IF ( section(is,s) >= nxl .AND. section(is,s) <= nxr )&
+                         THEN
+                            local_2d_l = local_2d
+                         ENDIF
+#if defined( __parallel )
+!
+!--                      Distribute data over all PEs along x
+                         ngp = ( nyn-nys+3 ) * ( nzt-nzb+2 )
+                         CALL MPI_ALLREDUCE( local_2d_l(nys-1,nzb),            &
+                                             local_2d(nys-1,nzb), ngp,         &
+                                             MPI_REAL, MPI_SUM, comm1dx, ierr )
+#else
+                         local_2d = local_2d_l
+#endif
+                         DEALLOCATE( local_2d_l )
+                      ENDIF
+!--                   END WORKAROUND-----------------------------------------
+
+!
+!--                   Output in NetCDF4/HDF5 format.
+!--                   Output only on those PEs where the respective cross
+!--                   sections reside. Cross sections averaged along x are
+!--                   output on the respective first PE along x (myidx=0).
+                      IF ( ( section(is,s) >= nxl  .AND.  &
+                             section(is,s) <= nxr )  .OR.  &
+                           ( section(is,s) == -1  .AND.  myidx == 0 ) )  THEN
+!
+!--                      Do not output redundant ghost point data except for the
+!--                      boundaries of the total domain.
 #if defined( __netcdf )
-                      IF ( netcdf_output  .AND.  myid == 0 )  THEN
-                         WRITE ( 23 )  simulated_time, do2d_yz_time_count(av), &
-                                       av
-                      ENDIF
-#endif
-                      IF ( ( section(is,s)>=nxl .AND. section(is,s)<=nxr ) .OR.&
-                           ( section(is,s) ==  -1  .AND.  nxl-1 == -1 ) )      &
-                      THEN
-                         WRITE (23)  nys-1, nyn+1, nzb, nzt+1
-                         WRITE (23)  local_2d
+                         IF ( nyn == ny )  THEN
+                            nc_stat = NF90_PUT_VAR( id_set_yz(av),             &
+                                                id_var_do2d(av,if),            &
+                                                local_2d(nys:nyn+1,nzb:nzt+1), &
+                                                start = (/ is, nys+1, 1,       &
+                                                    do2d_yz_time_count(av) /), &
+                                                count = (/ 1, nyn-nys+2,       &
+                                                           nzt+2, 1 /) )
+                         ELSE
+                            nc_stat = NF90_PUT_VAR( id_set_yz(av),             &
+                                                id_var_do2d(av,if),            &
+                                                local_2d(nys:nyn,nzb:nzt+1),   &
+                                                start = (/ is, nys+1, 1,       &
+                                                    do2d_yz_time_count(av) /), &
+                                                count = (/ 1, nyn-nys+1,       &
+                                                           nzt+2, 1 /) )
+                         ENDIF
+
+                         CALL handle_netcdf_error( 'data_output_2d', 60 )
+
                       ELSE
-                         WRITE (23)  -1, -1, -1, -1
+!
+!--                      Output on other PEs. Only one point is output!!
+!--                      ATTENTION: This is a workaround (see above)!!
+                         IF ( npex /= 1 )  THEN
+                            nc_stat = NF90_PUT_VAR( id_set_yz(av),             &
+                                                    id_var_do2d(av,if),        &
+                                                    local_2d(nys:nys,nzb:nzb), &
+                                                    start = (/ is, nys+1, 1,   &
+                                                    do2d_yz_time_count(av) /), &
+                                                    count = (/ 1, 1, 1, 1 /) )
+                            CALL handle_netcdf_error( 'data_output_2d', 452 )
+                         ENDIF
+#endif
                       ENDIF
 
                    ELSE
-!
-!--                   PE0 receives partial arrays from all processors of the 
-!--                   respective cross section and outputs them. Here a
-!--                   barrier has to be set, because otherwise 
-!--                   "-MPI- FATAL: Remote protocol queue full" may occur.
-                      CALL MPI_BARRIER( comm2d, ierr )
-
-                      ngp = ( nyn-nys+3 ) * ( nzt-nzb+2 )
-                      IF ( myid == 0 )  THEN
-!
-!--                      Local array can be relocated directly.
-                         IF ( ( section(is,s)>=nxl .AND. section(is,s)<=nxr )  &
-                           .OR. ( section(is,s) ==  -1  .AND.  nxl-1 == -1 ) ) &
+
+                      IF ( data_output_2d_on_each_pe )  THEN
+!
+!--                      Output of partial arrays on each PE. If the cross
+!--                      section does not reside on the PE, output special
+!--                      index values.
+#if defined( __netcdf )
+                         IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                            WRITE ( 23 )  simulated_time, &
+                                          do2d_yz_time_count(av), av
+                         ENDIF
+#endif
+                         IF ( ( section(is,s) >= nxl  .AND.                  &
+                                section(is,s) <= nxr )  .OR.                 &
+                              ( section(is,s) == -1  .AND.  nxl-1 == -1 ) )  &
                          THEN
-                            total_2d(nys-1:nyn+1,nzb:nzt+1) = local_2d
-                         ENDIF
-!
-!--                      Receive data from all other PEs.
-                         DO  n = 1, numprocs-1
-!
-!--                         Receive index limits first, then array.
-!--                         Index limits are received in arbitrary order from
-!--                         the PEs.
-                            CALL MPI_RECV( ind(1), 4, MPI_INTEGER,            &
-                                           MPI_ANY_SOURCE, 0, comm2d, status, &
-                                           ierr )
-!
-!--                         Not all PEs have data for YZ-cross-section.
-                            IF ( ind(1) /= -9999 )  THEN
-                               sender = status(MPI_SOURCE)
-                               DEALLOCATE( local_2d )
-                               ALLOCATE( local_2d(ind(1):ind(2),ind(3):ind(4)) )
-                               CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, &
-                                              MPI_REAL, sender, 1, comm2d,  &
+                            WRITE (23)  nys-1, nyn+1, nzb, nzt+1
+                            WRITE (23)  local_2d
+                         ELSE
+                            WRITE (23)  -1, -1, -1, -1
+                         ENDIF
+
+                      ELSE
+!
+!--                      PE0 receives partial arrays from all processors of the 
+!--                      respective cross section and outputs them. Here a
+!--                      barrier has to be set, because otherwise 
+!--                      "-MPI- FATAL: Remote protocol queue full" may occur.
+                         CALL MPI_BARRIER( comm2d, ierr )
+
+                         ngp = ( nyn-nys+3 ) * ( nzt-nzb+2 )
+                         IF ( myid == 0 )  THEN
+!
+!--                         Local array can be relocated directly.
+                            IF ( ( section(is,s) >= nxl  .AND.                 &
+                                   section(is,s) <= nxr )   .OR.               &
+                                 ( section(is,s) == -1  .AND.  nxl-1 == -1 ) ) &
+                            THEN
+                               total_2d(nys-1:nyn+1,nzb:nzt+1) = local_2d
+                            ENDIF
+!
+!--                         Receive data from all other PEs.
+                            DO  n = 1, numprocs-1
+!
+!--                            Receive index limits first, then array.
+!--                            Index limits are received in arbitrary order from
+!--                            the PEs.
+                               CALL MPI_RECV( ind(1), 4, MPI_INTEGER,     &
+                                              MPI_ANY_SOURCE, 0, comm2d,  &
                                               status, ierr )
-                               total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
+!
+!--                            Not all PEs have data for YZ-cross-section.
+                               IF ( ind(1) /= -9999 )  THEN
+                                  sender = status(MPI_SOURCE)
+                                  DEALLOCATE( local_2d )
+                                  ALLOCATE( local_2d(ind(1):ind(2), &
+                                                     ind(3):ind(4)) )
+                                  CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, &
+                                                 MPI_REAL, sender, 1, comm2d,  &
+                                                 status, ierr )
+                                  total_2d(ind(1):ind(2),ind(3):ind(4)) = &
+                                                                        local_2d
+                               ENDIF
+                            ENDDO
+!
+!--                         Output of the total cross-section.
+                            IF ( iso2d_output )  THEN
+                               WRITE (23)  total_2d(0:ny+1,nzb:nzt+1)
                             ENDIF
-                         ENDDO
-!
-!--                      Output of the total cross-section.
-                         IF ( iso2d_output )  THEN
-                            WRITE (23)  total_2d(0:ny+1,nzb:nzt+1)
-                         ENDIF
-!
-!--                      Relocate the local array for the next loop increment
-                         DEALLOCATE( local_2d )
-                         ALLOCATE( local_2d(nys-1:nyn+1,nzb:nzt+1) )
+!
+!--                         Relocate the local array for the next loop increment
+                            DEALLOCATE( local_2d )
+                            ALLOCATE( local_2d(nys-1:nyn+1,nzb:nzt+1) )
 
 #if defined( __netcdf )
-                         IF ( netcdf_output )  THEN
-                            nc_stat = NF90_PUT_VAR( id_set_yz(av),             &
+                            IF ( netcdf_output )  THEN
+                               nc_stat = NF90_PUT_VAR( id_set_yz(av),          &
                                                     id_var_do2d(av,if),        &
                                                     total_2d(0:ny+1,nzb:nzt+1),&
                                start = (/ is, 1, 1, do2d_yz_time_count(av) /), &
                                                 count = (/ 1, ny+2, nz+2, 1 /) )
-                            CALL handle_netcdf_error( 'data_output_2d', 60 )
-                         ENDIF
-#endif
-
-                      ELSE
-!
-!--                      If the cross section resides on the PE, send the
-!--                      local index limits, otherwise send -9999 to PE0.
-                         IF ( ( section(is,s)>=nxl .AND. section(is,s)<=nxr )  &
-                           .OR. ( section(is,s) ==  -1  .AND.  nxl-1 == -1 ) ) &
-                         THEN
-                            ind(1) = nys-1; ind(2) = nyn+1
-                            ind(3) = nzb;   ind(4) = nzt+1
+                               CALL handle_netcdf_error( 'data_output_2d', 61 )
+                            ENDIF
+#endif
+
                          ELSE
-                            ind(1) = -9999; ind(2) = -9999
-                            ind(3) = -9999; ind(4) = -9999
-                         ENDIF
-                         CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, &
-                                        ierr )
-!
-!--                      If applicable, send data to PE0.
-                         IF ( ind(1) /= -9999 )  THEN
-                            CALL MPI_SEND( local_2d(nys-1,nzb), ngp, MPI_REAL, &
-                                           0, 1, comm2d, ierr )
-                         ENDIF
-                      ENDIF
-!
-!--                   A barrier has to be set, because otherwise some PEs may
-!--                   proceed too fast so that PE0 may receive wrong data on
-!--                   tag 0
-                      CALL MPI_BARRIER( comm2d, ierr )
+!
+!--                         If the cross section resides on the PE, send the
+!--                         local index limits, otherwise send -9999 to PE0.
+                            IF ( ( section(is,s) >= nxl  .AND.                 &
+                                   section(is,s) <= nxr )  .OR.                &
+                                 ( section(is,s) == -1  .AND.  nxl-1 == -1 ) ) &
+                            THEN
+                               ind(1) = nys-1; ind(2) = nyn+1
+                               ind(3) = nzb;   ind(4) = nzt+1
+                            ELSE
+                               ind(1) = -9999; ind(2) = -9999
+                               ind(3) = -9999; ind(4) = -9999
+                            ENDIF
+                            CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, &
+                                           comm2d, ierr )
+!
+!--                         If applicable, send data to PE0.
+                            IF ( ind(1) /= -9999 )  THEN
+                               CALL MPI_SEND( local_2d(nys-1,nzb), ngp, &
+                                              MPI_REAL, 0, 1, comm2d, ierr )
+                            ENDIF
+                         ENDIF
+!
+!--                      A barrier has to be set, because otherwise some PEs may
+!--                      proceed too fast so that PE0 may receive wrong data on
+!--                      tag 0
+                         CALL MPI_BARRIER( comm2d, ierr )
+                      ENDIF
+
                    ENDIF
 #else
@@ -1173,5 +1424,5 @@
                                start = (/ is, 1, 1, do2d_xz_time_count(av) /), &
                                               count = (/ 1, ny+2, nz+2, 1 /) )
-                      CALL handle_netcdf_error( 'data_output_2d', 61 )
+                      CALL handle_netcdf_error( 'data_output_2d', 452 )
                    ENDIF
 #endif
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 486)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 493)
@@ -76,14 +76,21 @@
 !-- Open output file.
 !-- Also creates coordinate and fld-file for AVS.
-!-- In case of a run on more than one PE, each PE opens its own file and
+!-- For classic or 64bit NetCDF output or output of other (old) data formats,
+!-- for a run on more than one PE, each PE opens its own file and
 !-- writes the data of its subdomain in binary format (regardless of the format
 !-- the user has requested). After the run, these files are combined to one
 !-- file by combine_plot_fields in the format requested by the user (netcdf
-!-- and/or avs). 
-    IF ( avs_output  .OR.  ( numprocs > 1 ) )  CALL check_open( 30 )
-
-#if defined( __netcdf )
-    IF ( myid == 0  .AND.  netcdf_output )  CALL check_open( 106+av*10 )
-#endif
+!-- and/or avs).
+!-- For NetCDF4/HDF5 output, data is written in parallel into one file.
+    IF ( netcdf_output )  THEN
+       IF ( netcdf_data_format < 3 )  THEN
+          CALL check_open( 30 )
+          IF ( myid == 0 )  CALL check_open( 106+av*10 )
+       ELSE
+          CALL check_open( 106+av*10 )
+       ENDIF
+    ELSE
+       IF ( avs_output  .OR.  ( numprocs > 1 ) )  CALL check_open( 30 )
+    ENDIF
 
 !
@@ -94,11 +101,13 @@
 !-- Update the NetCDF time axis
 #if defined( __netcdf )
-    do3d_time_count(av) = do3d_time_count(av) + 1
-    IF ( myid == 0  .AND.  netcdf_output )  THEN
-       nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_time_3d(av), &
-                               (/ time_since_reference_point /),  &
-                               start = (/ do3d_time_count(av) /), &
-                               count = (/ 1 /) )
-       CALL handle_netcdf_error( 'data_output_3d', 376 )
+    IF ( myid == 0  .OR.  netcdf_data_format > 2 )  THEN
+       do3d_time_count(av) = do3d_time_count(av) + 1
+       IF ( netcdf_output )  THEN
+          nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_time_3d(av), &
+                                  (/ time_since_reference_point /),  &
+                                  start = (/ do3d_time_count(av) /), &
+                                  count = (/ 1 /) )
+          CALL handle_netcdf_error( 'data_output_3d', 376 )
+       ENDIF
     ENDIF
 #endif
@@ -376,9 +385,45 @@
 !--       Uncompressed output.
 #if defined( __parallel )
-          IF ( netcdf_output  .AND.  myid == 0 )  THEN
-             WRITE ( 30 )  simulated_time, do3d_time_count(av), av
+          IF ( netcdf_output )  THEN
+             IF ( netcdf_data_format < 3 )  THEN
+!
+!--             Classic or 64bit format. Data is output in parallel in FORTRAN
+!--             binary format here, and later collected into one file by
+!--             combine_plot_fields
+                IF ( myid == 0 )  THEN
+                   WRITE ( 30 )  simulated_time, do3d_time_count(av), av
+                ENDIF
+                WRITE ( 30 )  nxl-1, nxr+1, nys-1, nyn+1, nzb, nz_do3d
+                WRITE ( 30 )  local_pf
+
+             ELSE
+!
+!--             Output in NetCDF4/HDF5 format.
+!--             Do not output redundant ghost point data except for the
+!--             boundaries of the total domain.
+                IF ( nxr == nx  .AND.  nyn /= ny )  THEN
+                   nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if), &
+                                  local_pf(nxl:nxr+1,nys:nyn,nzb:nz_do3d),    &
+                      start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /), &
+                      count = (/ nxr-nxl+2, nyn-nys+1, nz_do3d-nzb+1, 1 /) )
+                ELSEIF ( nxr /= nx  .AND.  nyn == ny )  THEN
+                   nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if), &
+                                  local_pf(nxl:nxr,nys:nyn+1,nzb:nz_do3d),    &
+                      start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /), &
+                      count = (/ nxr-nxl+1, nyn-nys+2, nz_do3d-nzb+1, 1 /) )
+                ELSEIF ( nxr == nx  .AND.  nyn == ny )  THEN
+                   nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if), &
+                                  local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),  &
+                      start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /), &
+                      count = (/ nxr-nxl+2, nyn-nys+2, nz_do3d-nzb+1, 1 /) )
+                ELSE
+                   nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if), &
+                                  local_pf(nxl:nxr,nys:nyn,nzb:nz_do3d),      &
+                      start = (/ nxl+1, nys+1, nzb+1, do3d_time_count(av) /), &
+                      count = (/ nxr-nxl+1, nyn-nys+1, nz_do3d-nzb+1, 1 /) )
+                ENDIF
+                CALL handle_netcdf_error( 'data_output_3d', 386 )
+             ENDIF
           ENDIF
-          WRITE ( 30 )  nxl-1, nxr+1, nys-1, nyn+1, nzb, nz_do3d
-          WRITE ( 30 )  local_pf
 #else
           IF ( avs_output )  THEN
@@ -387,9 +432,11 @@
 #if defined( __netcdf )
           IF ( netcdf_output )  THEN
-             nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),       &
-                                  local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),  &
-                                  start = (/ 1, 1, 1, do3d_time_count(av) /), &
-                                  count = (/ nx+2, ny+2, nz_do3d-nzb+1, 1 /) )
-             CALL handle_netcdf_error( 'data_output_3d', 386 )
+
+             nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_do3d(av,if),    &
+                               local_pf(nxl:nxr+1,nys:nyn+1,nzb:nz_do3d),  &
+                               start = (/ 1, 1, 1, do3d_time_count(av) /), &
+                               count = (/ nx+2, ny+2, nz_do3d-nzb+1, 1 /) )
+             CALL handle_netcdf_error( 'data_output_3d', 446 )
+
           ENDIF
 #endif
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 486)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 493)
@@ -53,9 +53,8 @@
     CALL cpu_log (log_point(49),'data_output_mask','start')
 
-!!
+!
 !-- Open output file.
-    IF ( format_parallel_io .AND. netcdf_output )  THEN
-       CALL check_open( 120+mid+av*max_masks )
-    ELSEIF (myid == 0  .AND.  netcdf_output ) THEN
+    IF ( netcdf_output  .AND.  ( myid == 0  .OR.  netcdf_data_format > 2 ) ) &
+    THEN
        CALL check_open( 120+mid+av*max_masks )
     ENDIF 
@@ -74,11 +73,6 @@
 !-- Update the NetCDF time axis.
     domask_time_count(mid,av) = domask_time_count(mid,av) + 1
-    IF ( format_parallel_io .AND. netcdf_output )  THEN
-       nc_stat = NF90_PUT_VAR( id_set_mask(mid,av), id_var_time_mask(mid,av), &
-                               (/ simulated_time /),                          &
-                               start = (/ domask_time_count(mid,av) /),       &
-                               count = (/ 1 /) )
-       CALL handle_netcdf_error( 'data_output_mask', 9998 )
-    ELSEIF ( myid == 0  .AND.  netcdf_output )  THEN
+    IF ( netcdf_output  .AND.  ( myid == 0  .OR.  netcdf_data_format > 2 ) ) &
+    THEN
        nc_stat = NF90_PUT_VAR( id_set_mask(mid,av), id_var_time_mask(mid,av), &
                                (/ simulated_time /),                          &
@@ -95,5 +89,5 @@
 !
 !--    Reallocate local_pf on PE 0 since its shape changes during MPI exchange
-       IF ( .NOT. format_parallel_io .AND. myid == 0 .AND. if > 1 )  THEN
+       IF ( netcdf_data_format < 3   .AND.  myid == 0  .AND.  if > 1 )  THEN
           DEALLOCATE( local_pf )
           ALLOCATE( local_pf(mask_size_l(mid,1),mask_size_l(mid,2), &
@@ -329,8 +323,8 @@
 !--    The choice of method depends on the correct setting of preprocessor
 !--    directives __parallel and __netcdf4 as well as on the parameter 
-!--    nc_format_mask(mid,av).
+!--    netcdf_data_format.
 #if defined( __parallel )
 #if defined( __netcdf4 )
-       IF ( nc_format_mask(mid,av) == 3 .OR. nc_format_mask(mid,av) == 4 )  THEN
+       IF ( netcdf_data_format > 2 )  THEN
 !
 !--       (1) a. Parallel I/O using NetCDF 4 (not yet tested)
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 486)
+++ palm/trunk/SOURCE/header.f90	(revision 493)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! NetCDF data output format extendend for NetCDF4/HDF5
 ! 
 ! Former revisions:
@@ -16,5 +16,5 @@
 ! 410 2009-12-04 17:05:40Z letzel
 ! Masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
-! mask_scale|_x|y|z, masks, netcdf_format_mask[_av], skip_time_domask
+! mask_scale|_x|y|z, masks, skip_time_domask
 !
 ! 346 2009-07-06 10:13:41Z raasch
@@ -700,8 +700,8 @@
        output_format = ''
        IF ( netcdf_output )  THEN
-          IF ( netcdf_64bit )  THEN
-             output_format = 'netcdf (64 bit offset)'
+          IF ( netcdf_data_format == 1 )  THEN
+             output_format = 'NetCDF classic'
           ELSE
-             output_format = 'netcdf'
+             output_format = 'NetCDF 64bit offset'
           ENDIF
        ENDIF
@@ -778,8 +778,12 @@
           output_format = ''
           IF ( netcdf_output )  THEN
-             IF ( netcdf_64bit )  THEN
-                output_format = 'netcdf (64 bit offset)'
-             ELSE
-                output_format = 'netcdf'
+             IF ( netcdf_data_format == 1 )  THEN
+                output_format = 'NetCDF classic'
+             ELSEIF ( netcdf_data_format == 2 )  THEN
+                output_format = 'NetCDF 64bit offset'
+             ELSEIF ( netcdf_data_format == 3 )  THEN
+                output_format = 'NetCDF4/HDF5'
+             ELSEIF ( netcdf_data_format == 4 )  THEN
+                output_format = 'NetCDF4/HDF5 clasic'
              ENDIF
           ENDIF
@@ -935,8 +939,12 @@
           output_format = ''
           IF ( netcdf_output )  THEN
-             IF ( netcdf_64bit_3d )  THEN
-                output_format = 'netcdf (64 bit offset)'
-             ELSE
-                output_format = 'netcdf'
+             IF ( netcdf_data_format == 1 )  THEN
+                output_format = 'NetCDF classic'
+             ELSEIF ( netcdf_data_format == 2 )  THEN
+                output_format = 'NetCDF 64bit offset'
+             ELSEIF ( netcdf_data_format == 3 )  THEN
+                output_format = 'NetCDF4/HDF5'
+             ELSEIF ( netcdf_data_format == 4 )  THEN
+                output_format = 'NetCDF4/HDF5 clasic'
              ENDIF
           ENDIF
@@ -1029,14 +1037,13 @@
              output_format = ''
              IF ( netcdf_output )  THEN
-                SELECT CASE ( nc_format_mask(mid,av) )
-                   CASE ( 1 )
-                      output_format = 'netcdf (classic format)'
-                   CASE ( 2 )
-                      output_format = 'netcdf (64bit offset format)'
-                   CASE ( 3 )
-                      output_format = 'netcdf (NetCDF 4 format)'
-                   CASE ( 4 )
-                      output_format = 'netcdf (NetCDF 4 classic model format)'
-                END SELECT
+                IF ( netcdf_data_format == 1 )  THEN
+                   output_format = 'NetCDF classic'
+                ELSEIF ( netcdf_data_format == 2 )  THEN
+                   output_format = 'NetCDF 64bit offset'
+                ELSEIF ( netcdf_data_format == 3 )  THEN
+                   output_format = 'NetCDF4/HDF5'
+                ELSEIF ( netcdf_data_format == 4 )  THEN
+                   output_format = 'NetCDF4/HDF5 clasic'
+                ENDIF
              ENDIF
              WRITE ( io, 344 )  output_format
@@ -1092,8 +1099,8 @@
        output_format = ''
        IF ( netcdf_output )  THEN
-          IF ( netcdf_64bit )  THEN
-             output_format = 'netcdf (64 bit offset)'
+          IF ( netcdf_data_format == 1 )  THEN
+             output_format = 'NetCDF classic'
           ELSE
-             output_format = 'netcdf'
+             output_format = 'NetCDF 64bit offset'
           ENDIF
        ENDIF
@@ -1169,8 +1176,8 @@
        output_format = ''
        IF ( netcdf_output )  THEN
-          IF ( netcdf_64bit )  THEN
-             output_format = 'netcdf (64 bit offset)'
+          IF ( netcdf_data_format == 1 )  THEN
+             output_format = 'NetCDF classic'
           ELSE
-             output_format = 'netcdf'
+             output_format = 'NetCDF 64bit offset'
           ENDIF
        ENDIF
@@ -1493,5 +1500,5 @@
           output_format = ''
           IF ( netcdf_output )  THEN
-             IF ( netcdf_64bit )  THEN
+             IF ( netcdf_data_format > 1 )  THEN
                 output_format = 'netcdf (64 bit offset) and binary'
              ELSE
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 486)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 493)
@@ -48,21 +48,11 @@
     ALLOCATE( mask(max_masks,3,mask_xyz_dimension), &
               mask_loop(max_masks,3,3) )
-!
-!-- Store netcdf file formats for masked data output in one shared array
-    nc_format_mask(:,0) = netcdf_format_mask
-    nc_format_mask(:,1) = netcdf_format_mask_av
     
-    IF ( ANY( nc_format_mask == 3 ) .OR. ANY( nc_format_mask == 4 )) THEN
-       format_parallel_io = .TRUE.
-    ENDIF
-
-    IF ( ANY( nc_format_mask < 1 ) .OR. ANY( nc_format_mask > 4 ) )  THEN
-       WRITE( message_string, * )  'illegal value: netcdf_format_mask and ', &
-            'netcdf_format_mask_av must be either 1, 2, 3 or 4'
-       IF ( ANY( nc_format_mask == 3 ) .OR. ANY( nc_format_mask == 4 ) )  THEN
-          message_string = TRIM( message_string ) // '&NetCDF file formats '// &
-               '3 (NetCDF 4) and 4 (NetCDF 4 Classic model)'// &
-               '&are currently not supported (not yet tested).'
-       ENDIF
+!
+!-- Parallel mask output not yet tested
+    IF ( netcdf_data_format > 2 )  THEN
+       message_string = 'NetCDF file formats '//                         &
+                        '3 (NetCDF 4) and 4 (NetCDF 4 Classic model)'//  &
+                        '&are currently not supported (not yet tested).'
        CALL message( 'init_masks', 'PA9998', 1, 2, 0, 6, 0 )
     ENDIF
@@ -162,10 +152,5 @@
 !
 !-- Global arrays are required by define_netcdf_header.
-    IF ( format_parallel_io )  THEN
-       ALLOCATE( mask_i_global(max_masks,nx+1), &
-                 mask_j_global(max_masks,ny+1), &
-                 mask_k_global(max_masks,nz+1) )
-       mask_i_global = -1; mask_j_global = -1; mask_k_global = -1
-    ELSEIF ( myid == 0 )  THEN
+    IF ( myid == 0  .OR.  netcdf_data_format > 2 )  THEN
        ALLOCATE( mask_i_global(max_masks,nx+1), &
                  mask_j_global(max_masks,ny+1), &
@@ -472,9 +457,12 @@
        CALL MPI_BARRIER( comm2d, ierr )
        
-       IF ( format_parallel_io )  THEN  
+       IF ( netcdf_data_format > 2 )  THEN  
          
-          CALL MPI_BCAST( mask_i_global(mid,:), nx+1, MPI_INTEGER, 0, comm2d, ierr )
-          CALL MPI_BCAST( mask_j_global(mid,:), ny+1, MPI_INTEGER, 0, comm2d, ierr )
-          CALL MPI_BCAST( mask_k_global(mid,:), nz+1, MPI_INTEGER, 0, comm2d, ierr ) 
+          CALL MPI_BCAST( mask_i_global(mid,:), nx+1, MPI_INTEGER, 0, comm2d, &
+                          ierr )
+          CALL MPI_BCAST( mask_j_global(mid,:), ny+1, MPI_INTEGER, 0, comm2d, &
+                          ierr )
+          CALL MPI_BCAST( mask_k_global(mid,:), nz+1, MPI_INTEGER, 0, comm2d, &
+                          ierr ) 
 	  
        ENDIF
@@ -496,4 +484,5 @@
 
  CONTAINS
+
     SUBROUTINE set_mask_locations( dim, dxyz, dxyz_string, nxyz, nxyz_string, &
                                    lb, ub )
